#if defined(LINUX) || defined(INTERIX) || defined(CYGWIN)  || defined(SCOUNX) || defined(SUNSOLARIS)
/* for abstract data types (struct that we use only as pointers),
   gcc on linux, and most other compilers, will let us squelch
   those silly warnings if we declare the struct with no memebers.
   It's a kind of "forward" declaration...
*/

struct IsamPath;
struct IsamNode;
struct IsamFree;
struct IsamFile;
struct decacc;
struct AdmDup;
struct _userlist;

#endif

#ifdef DISAM8 
#define ISAMSIGNTYPE       /* define for disam8 */
#else
#define ISAMSIGNTYPE  unsigned  /* define for isam12 */
#endif

extern int dec_round(struct decacc *s,int c);
extern int decadd(struct decimal *x,struct decimal *y,struct decimal *r);
extern int deccmp(struct decimal *x,struct decimal *y);
extern int deccvint(int i,struct decimal *dp);
extern int dectoint(struct decimal *dp,int *ip);
extern int deccvlong(long i,struct decimal *dp);
extern int dectolong(struct decimal *dp,long *ip);
static int deccvfix(long i,struct decimal *dp);
static int dectofix(struct decimal *dp,long *ip);
extern int deccvdbl(double dbl,struct decimal *dp);
extern int dectodbl(struct decimal *dp,double *dblp);
extern int deccvflt(double flt,struct decimal *dp);
extern int dectoflt(struct decimal *dp,float *fltp);
static int deccvreal(double dbl,struct decimal *dp,int ndigits);
static int dectoreal(struct decimal *dp,double *dblp,int valid);
extern int stdecimal(struct decimal *dp,unsigned char *cp,int len);
extern int lddecimal(unsigned char *cp,int len,struct decimal *dp);
static void comp100(unsigned char *cp,int count);
static int round100(unsigned char *cp,int len);
extern int deccvasc(char *cp,int ln,struct decimal *rp);
extern int decdiv(struct decimal *x,struct decimal *y,struct decimal *r);
extern char *dececvt(struct decimal *np,int dg,int *pt,int *sg);
extern char *decefcvt(struct decimal *np,int dg,int *pt,int *sg,int fl);
extern int decchs(struct decimal *np);
extern int decround(struct decimal *np,int prec);
extern int dectrunc(struct decimal *np,int prec);
extern int isdbdec(struct decimal *dec);
extern char *decfcvt(struct decimal *np,int dg,int *pt,int *sg);
extern int decmul(struct decimal *x,struct decimal *y,struct decimal *r);
extern int mod100(int c,int *d);
extern int decsub(struct decimal *x,struct decimal *y,struct decimal *r);
extern int dectoasc(struct decimal *np,char *cp,int ln,int dg);
extern int deccopy(struct decimal *n1,struct decimal *n2);
extern int issusplog(void);
extern int isresumlog(void);
extern int isvclose(void);
extern int isLock(struct IsamFile *isam);
extern int isUnLock(struct IsamFile *isam);
extern int isRelease(struct IsamFile *isam);
extern int isRelRec(struct IsamFile *isam, ISAMSIGNTYPE long recnum);
extern int isRelCurr(struct IsamFile *isam);
extern int isThreaded(void );
extern int isAdmDtoI(struct IsamFile *isam);
extern struct IsamFile *isAdmItoD(int id);
extern int isCleanUp(void );
extern int isAdmOpen(struct IsamFile *isam);
extern int isAdmCheck(struct IsamFile *isam);
extern int isAdmClose(struct IsamFile *isam);
extern int isAdmDupData(struct IsamFile *isam,long recnum,int wait);
extern void isAdmCrit(struct IsamFile *isam,int mode);
extern void isAdmSafe(struct IsamFile *isam,int mode);
extern void isAdmFail(struct IsamFile *isam);
extern int isAdmDupLock(struct IsamFile *isam,int mode);
extern int isAdmDupDrop(struct IsamFile *isam);
static int newitem(void );
static struct IsamFile *getisam(int id);
static int dupopen(struct IsamFile *isam,int id);
static int dupclose(struct IsamFile *isam,int id);
/* static int dupcount(struct AdmDup *dup); compiler warning */
static int findname(char *name);
static int getdatlen(struct IsamFile *isam);
extern struct IsamFile *isBuild(char *name,int dlen,int mlen,struct keydesc *kdsc,int mode);
extern int isPrecious(struct IsamFile *isam,int flag);
extern int isAddIndex(struct IsamFile *isam,struct keydesc *kdsc);
extern int isFillIdx(struct IsamFile *isam,int idx);
extern int isCheckData(struct IsamFile *isam);
extern int isCheckIndex(struct IsamFile *isam,int idx);
extern int isRebuildFree(struct IsamFile *isam,int which);
extern int isRebuildIdx(struct IsamFile *isam,int idx);
static int datamatch(struct IsamFile *isam,struct IsamPath *path);
extern struct IsamFile *isCluster(struct IsamFile *isam,struct keydesc *kdsc);
extern struct IsamFile *isClone(struct IsamFile *isam,char *name);
extern int isCopy(struct IsamFile *dest,struct IsamFile *source,struct keydesc *kdsc);
static int mktempname(char *temp,char *orig);
extern int isCompKey(char *dest,char *old,char *new,int flags,int len);
extern int isCompNext(struct IsamNode *node,int flags,int klen,int dlen,int off);
extern int isCompScan(char *image,char *value,int start,int stop,int flags,int klen,int dlen);
extern int isCustLen(int type);
extern int isCustCmp(struct keydesc *kdsc,int part,char *one,char *two);
static int bytecmp(char *one,char *two);
static int quadcmp(char *one,char *two);
static int rfacmp(char *one,char *two);
extern int isGetData(struct IsamFile *isam,char *pad, ISAMSIGNTYPE long recnum);
extern int isPutData(struct IsamFile *isam,char *pad, ISAMSIGNTYPE long recnum);
extern int isDelCheck(struct IsamFile *isam, ISAMSIGNTYPE long recnum);
extern int isDelData(struct IsamFile *isam, ISAMSIGNTYPE long recnum);
extern int isDelete(struct IsamFile *isam,char *pad);
extern int isDelCurr(struct IsamFile *isam);
extern int isDelRec(struct IsamFile *isam, ISAMSIGNTYPE long recnum);
static int delete(struct IsamFile *isam, ISAMSIGNTYPE long recnum);
static int delpure(struct IsamFile *isam,int check);
extern int isEntry(struct IsamFile *isam,int workmode);
extern int isDelta(struct IsamFile *isam);
extern int isFail(struct IsamFile *isam,int iserrno,int iserrio);
extern void isFatal(void (*call)(char *));
extern void is_fatal(char *fmt,...);
extern int isErase(char *name);
extern int isRename(char *oname,char *nname);
static struct IsamFile *tempopen(char *name);
static int tempclose(struct IsamFile *isam);
extern long isGetFree(struct IsamFile *isam,int which);
extern int isPutFree(struct IsamFile *isam,int which,long recnum);
extern long isFreeCount(struct IsamFile *isam,int which,int (*call)(char *));
extern int isFreeClear(struct IsamFile *isam,int mode);
extern int isFreeWrite(struct IsamFile *isam);
extern int isFreeFree(struct IsamFile *isam);
extern int isFreeDrop(struct IsamFile *isam,int which);
static int refresh(struct IsamFile *isam,struct IsamFree *list);
extern int isTreeInsert(struct IsamFile *isam,struct IsamPath *path,char *key,long recnum);
static int flatgrow(struct IsamFile *isam,struct IsamPath *path,struct IsamNode *node,char *newkey,long recnum,int mode);
static int flatins(struct IsamPath *path,struct IsamNode *node,int nodemax,int slotlen,int keylen,char *newkey,int keyoff,long recnum,long dupnum,int duplen);
static int compgrow(struct IsamFile *isam,struct IsamPath *path,struct IsamNode *node,char *newkey,long recnum,int mode);
static int compins(struct IsamPath *path,struct IsamNode *node,int nodemax,int kflags,int keylen,char *newkey,int keyoff,long recnum,long *dupnum,int duplen);
static int comphalf(struct IsamPath *path,struct IsamNode *node,char *value);
static int insertpoint(struct IsamFile *isam,struct IsamPath *path,char *target);
static int initroot(struct IsamFile *isam,struct IsamNode *node,int level);
static long nextdup(struct IsamPath *path);
extern int isUserInfo(struct IsamFile *isam,int mode,char *pad);
extern int isMakeHead(struct IsamFile *isam);
extern int isLoadHead(struct IsamFile *isam);
extern int isHeadWrite(struct IsamFile *isam);
extern int isHeadKdsc(struct IsamFile *isam);
extern int isHeadFree(struct IsamFile *isam,int which,struct IsamFree *list);
static int bootstrap(struct IsamFile *isam);
static void loadflags(struct IsamFile *isam);
static void saveflags(struct IsamFile *isam);
extern int isDelIndex(struct IsamFile *isam,struct keydesc *kdsc);
extern int isWipeIdx(struct IsamFile *isam,int idx);
static int deletepath(struct IsamFile *isam,struct IsamPath *path);
extern int isRefNode(struct IsamFile *isam,struct IsamNode *node);
extern int isUpdNode(struct IsamFile *isam,struct IsamNode *node);
extern int isGetNode(struct IsamFile *isam,char *image,long idxrec);
extern int isPutNode(struct IsamFile *isam,char *image,long idxrec);
extern int isMarkNode(struct IsamFile *isam,char *image,int low,int high);
extern int isLoadIndexes(struct IsamFile *isam);
extern int isTestIndex(struct IsamFile *isam,struct keydesc *kdsc);
extern int isFindIndex(struct IsamFile *isam,struct keydesc *kdsc);
extern int isMakeIndex(struct IsamFile *isam,struct keydesc *kdsc);
extern int isDropIndex(struct IsamFile *isam,int idx);
extern int isFreeIndex(struct IsamFile *isam,int idx);
static int instpath(struct IsamFile *isam,struct keydesc *kdsc);
static int initpath(struct IsamFile *isam,struct IsamPath *path);
static int freepath(struct IsamFile *isam,int idx);
extern int isIndexInfo(struct IsamFile *isam,struct keydesc *kdsc,int idx);
extern int isIsamInfo(struct IsamFile *isam,struct dictinfo *dict);
extern int isErrno(struct IsamFile *isam);
extern int isErrio(struct IsamFile *isam);
extern ISAMSIGNTYPE long isRecnum(struct IsamFile *isam);
extern long isReclen(struct IsamFile *isam);
extern int isSetrec(struct IsamFile *isam,ISAMSIGNTYPE long recnum);
extern int isSetlen(struct IsamFile *isam,short reclen);
static int dictload(struct IsamFile *isam,struct dictinfo *dict);
extern int isKeyMake(struct IsamPath *path,char *dest,char *pad);
extern int isKeyLoad(struct IsamPath *path,char *dest,char *key);
extern int isKeyCmp(struct IsamPath *path,char *one,char *two);
extern int isKeyMatch(struct IsamPath *path,char *one,char *two);
extern int isKeyNull(struct IsamPath *path,char *key);
static int findoff(char *one,char *two,int len);
static int signcmp(char *one,char *two,int off);
static int flatcmp(char *one,char *two,int off);
static int mintcmp(char *one,char *two,int off);
static int mlongcmp(char *one,char *two,int off);
static int floatcmp(char *one,char *two,int off);
static int doublecmp(char *one,char *two,int off);
extern int isGetLastRec(struct IsamFile *isam,ISAMSIGNTYPE long *last);
extern int isSetLastRec(struct IsamFile *isam,ISAMSIGNTYPE long last);
extern int isLastRec(struct IsamFile *isam,ISAMSIGNTYPE long *last);
extern int isLocate(struct IsamFile *isam,char *pad,int mode);
extern int isEdge(struct IsamFile *isam,struct IsamPath *path,int mode);
extern int isWalk(struct IsamFile *isam,struct IsamPath *path,int mode);
extern int isFind(struct IsamFile *isam,struct IsamPath *path,char *key,int mode);
extern long isCurrent(struct IsamFile *isam);
static int indexed(struct IsamFile *isam,char *pad,int mode);
static int natural(struct IsamFile *isam,int mode);
extern int isLockOpen(struct IsamFile *isam);
extern int isLockExcl(struct IsamFile *isam);
extern int isDropExcl(struct IsamFile *isam);
extern int isDropFile(struct IsamFile *isam);
extern int isLockRead(struct IsamFile *isam);
extern int isLockWrite(struct IsamFile *isam);
extern int isDropLock(struct IsamFile *isam);
extern int isLocked(struct IsamFile *isam,long recnum);
extern int isLockTest(struct IsamFile *isam,long recnum);
extern int isLockData(struct IsamFile *isam,long recnum,int wait);
extern int isDropData(struct IsamFile *isam,long recnum);
extern int isLockDall(struct IsamFile *isam);
extern int isDropDall(struct IsamFile *isam);
static int findslot(struct IsamFile *isam,long recnum);
static long getoff(int what);
static int setlock(struct IsamFile *isam,int what,int mode,int wait);
static void droplock(struct IsamFile *isam,int what,int mode);
static void droplist(struct IsamFile *isam);
static int lockdata(struct IsamFile *isam,long recnum,int wait);
static void dropdata(struct IsamFile *isam,long recnum);
extern char *is_malloc(int len);
extern char *is_realloc(char *ptr,int old,int new);
extern char *is_free(char *ptr);
extern void is_memset(char *dest,int val,int len);
extern long ldMint(char *pad,int len);
extern int stMint(char *pad,int len,long val);
extern int ld_int(char *pad);
extern int st_int(int value,char *pad);
extern long ld_long(char *pad);
extern int st_long(long value,char *pad);
extern int ldInt(char *pad);
extern int stInt(int value,char *pad);
extern long ldLong(char *pad);
extern int stLong(long value,char *pad);
extern int stChar(char *str,char *pad,int len);
extern int ldChar(char *pad,int len,char *str);
extern float ldFloat(char *pad);
extern int stFloat(float value,char *pad);
extern double ldDbl(char *pad);
extern int stDbl(double value,char *pad);
extern int stFltNull(float value,char *pad,short null);
extern float ldFltNull(char *pad,short *null);
extern int stDblNull(double value,char *pad,short null);
extern double ldDblNull(char *pad,short *null);
extern struct IsamNode *isMakeNode(struct IsamFile *isam,struct IsamPath *path);
extern int isInitInfo(struct IsamFile *isam,struct IsamNode *node);
extern struct IsamNode *isFreeNode(struct IsamNode *node);
extern int isNodeWalk(struct IsamPath *path,int mode);
extern int isNodeMatch(struct IsamPath *path,char *target);
extern int isNodeGreat(struct IsamPath *path,char *target);
static int flatwalk(struct IsamPath *path,int mode);
static int flatmatch(struct IsamPath *path,struct IsamNode *node,char *target);
static int flatgreat(struct IsamPath *path,struct IsamNode *node,char *target);
static int flatoff(struct IsamPath *path,struct IsamNode *node,int mode);
static int flatval(struct IsamPath *path,struct IsamNode *node,int off);
static int compwalk(struct IsamPath *path,int mode);
static int compmatch(struct IsamPath *path,struct IsamNode *node,char *target);
static int compgreat(struct IsamPath *path,struct IsamNode *node,char *target);
static int compval(struct IsamPath *path,struct IsamNode *node,int off,int end);
extern struct IsamFile *isOpen(char *name,int mode);
extern int isClose(struct IsamFile *isam);
extern int isLockCheck(struct IsamFile *isam,int flag);
extern int isSetMode(struct IsamFile *isam,int mode);
extern int isPathIns(struct IsamFile *isam,struct IsamPath *path,long idxrec);
extern int isPathSplit(struct IsamFile *isam,struct IsamPath *path);
extern int isPathAdd(struct IsamFile *isam,struct IsamPath *path,long idxrec);
extern int isPathDown(struct IsamFile *isam,struct IsamPath *path);
extern int isPathClear(struct IsamFile *isam,int mode);
extern int isPathWrite(struct IsamFile *isam,int idx);
extern int isPathFree(struct IsamFile *isam,struct IsamPath *path);
static int pathwrite(struct IsamFile *isam,struct IsamPath *path);
static struct IsamNode *findnode(struct IsamNode **buf ,long idxrec);
static int dropnode(struct IsamNode **buf ,struct IsamNode *node);
static int dropnode2(struct IsamNode **buf ,struct IsamNode *node);
static int clearbuf(struct IsamNode **buf ,int mode);
static int writebuf(struct IsamFile *isam,struct IsamNode **buf );
static int freebuf(struct IsamFile *isam,struct IsamNode **buf );
extern int isTreeDelete(struct IsamFile *isam,struct IsamPath *path,char *key,long rec);
static int flatdelete(struct IsamFile *isam,struct IsamPath *path);
static int flatsquash(struct IsamPath *path,struct IsamNode *node);
static int compdelete(struct IsamFile *isam,struct IsamPath *path);
static int compsquash(struct IsamPath *path,struct IsamNode *node);
static int quickcheck(struct IsamPath *path,long rec);
static int searchfind(struct IsamFile *isam,struct IsamPath *path,char *key,long rec);
static int endcheck(struct IsamFile *isam,struct IsamNode *node);
extern int isRead(struct IsamFile *isam,char *pad,int mode);
extern int isStart(struct IsamFile *isam,struct keydesc *key,int len,char *pad,int mode);
extern int isIndex(struct IsamFile *isam,int idx);
extern int isGoto(struct IsamFile *isam,ISAMSIGNTYPE long recnum);
extern int isData(struct IsamFile *isam,char *pad,ISAMSIGNTYPE long recnum);
extern int isPush(struct IsamFile *isam,int *idx,ISAMSIGNTYPE long *rec);
extern int isPop(struct IsamFile *isam,int idx,ISAMSIGNTYPE long rec);
static int datlock(struct IsamFile *isam,int lock);
static int locrec(struct IsamFile *isam,long recnum);
static void readfail(struct IsamFile *isam,int mode);
static void startfail(struct IsamFile *isam,int mode);
extern char *isDbuffer(int buflen);
extern int isDsquash(char *data,int datlen);
extern int isDexpand(char *dest);
static int tmpsize(int newlen);
static int rle(unsigned char *dest,unsigned char *data,int dlen);
static int rleHead(unsigned char *dest,unsigned char *data,int dlen);
static int rleBody(unsigned char *dest,unsigned char *data,int hlen);
static int rld(unsigned char *data,unsigned char *comp);
extern int is_create(struct IsamFile *isam,int which,char *name);
extern int is_open(struct IsamFile *isam,int which,char *name);
extern int is_close(struct IsamFile *isam,int which);
extern int is_read(struct IsamFile *isam,int which,char *pad,int len,long off);
extern int is_write(struct IsamFile *isam,int which,char *pad,int len,long off);
extern unsigned long is_size(struct IsamFile *isam,int which);
extern unsigned long is_tell(struct IsamFile *isam,int which);
extern int is_unlink(struct IsamFile *isam,int which,char *name);
extern int is_rename(struct IsamFile *isam,int which,char *old,char *new);
extern int is_lock(struct IsamFile *isam,int which,long off,long len,int wait);
extern int is_drop(struct IsamFile *isam,int which,long off,long len);
extern long is_getpid(struct IsamFile *isam);
extern long is_getuid(struct IsamFile *isam);
static int makename(char *pad,char *name,int which);
extern int testlink(char *dest,char *path);
static int storefd(struct IsamFile *isam,int fd,int which);
static int loadfd(struct IsamFile *isam,int which);
extern int isTreeFirst(struct IsamFile *isam,struct IsamPath *path);
extern int isTreeLast(struct IsamFile *isam,struct IsamPath *path);
extern int isTreeCurr(struct IsamFile *isam,struct IsamPath *path);
extern int isTreePrev(struct IsamFile *isam,struct IsamPath *path);
extern int isTreeNext(struct IsamFile *isam,struct IsamPath *path);
extern int isTreeMatch(struct IsamFile *isam,struct IsamPath *path,char *target);
extern int isTreeGreat(struct IsamFile *isam,struct IsamPath *path,char *target);
static int walkedge(struct IsamFile *isam,struct IsamPath *path,int mode);
static int currmatch(struct IsamFile *isam,struct IsamPath *path);
extern int isSetUnique(struct IsamFile *isam,ISAMSIGNTYPE long value);
extern int isUniqueId(struct IsamFile *isam,ISAMSIGNTYPE long *dest);
extern int isRewrite(struct IsamFile *isam,char *newpad);
extern int isRewCurr(struct IsamFile *isam,char *newpad);
extern int isRewRec(struct IsamFile *isam,ISAMSIGNTYPE long recnum,char *newpad);
extern int isRewNxt(struct IsamFile *isam,char *newpad);
static int rewrite(struct IsamFile *isam,char *newpad,long recnum);
static int rewpure(struct IsamFile *isam,char *newpad,int check);
extern int isWrite(struct IsamFile *isam,char *pad);
extern int isWrLock(struct IsamFile *isam,char *pad);
extern int isWrCurr(struct IsamFile *isam,char *pad);
static long insert(struct IsamFile *isam,char *pad);
static long inspure(struct IsamFile *isam,char *pad);
extern int isbuild(char *name,int len,struct keydesc *kdsc,int mode);
extern int isvbuild(char *name,int len,int max,struct keydesc *kdsc,int mode);
extern int isaddindex(int isfd,struct keydesc *kdsc);
extern int isdelindex(int isfd,struct keydesc *kdsc);
extern int iscluster(int isfd,struct keydesc *kdsc);
extern int isclone(int isfd,char *name);
extern int iscopy(int dfd,int sfd,struct keydesc *kdsc);
extern int ischeckdata(int isfd);
extern int ischeckindex(int isfd,int idx);
extern int iserase(char *name);
extern int isrename(char *oname,char *nname);
extern int isflush(int isfd);
extern int issetunique(int isfd,ISAMSIGNTYPE long value);
extern int isuniqueid(int isfd,ISAMSIGNTYPE long *dest);
extern int isprecious(int isfd,int flag);
extern int islockcheck(int isfd,int flag);
extern char *isseekey(int isfd);
extern void isfatal(void (*call)(char *));
extern int isthreaded(void );
extern int isindexinfo(int isfd,struct keydesc *dest,int idx);
extern int isisaminfo(int isfd,struct dictinfo *dest);
extern int isuserinfo(int isfd,int mode,char *pad);
extern char *isdi_name(int isfd);
extern int isdi_datlen(int isfd);
extern int isdi_curidx(int isfd);
extern int isdi_idxfd(int isfd);
extern int isdi_datfd(int isfd);
extern struct keydesc *isdi_kdsc(int isfd);
extern int islastrec(int isfd,ISAMSIGNTYPE long *last);
extern int isgetlastrec(int isfd,ISAMSIGNTYPE long *last);
extern int issetlastrec(int isfd,ISAMSIGNTYPE long last);
extern int islock(int isfd);
extern int isunlock(int isfd);
extern int isrelease(int isfd);
extern int isrelrec(int isfd,ISAMSIGNTYPE long recnum);
extern int isrelcurr(int isfd);
extern int ldint(char *pad);
extern int stint(int value,char *pad);
extern long ldlong(char *pad);
extern int stlong(long value,char *pad);
extern int stchar(char *str,char *pad,int len);
extern int ldchar(char *pad,int len,char *str);
extern float ldfloat(char *pad);
extern int stfloat(float value,char *pad);
extern double lddbl(char *pad);
extern int stdbl(double value,char *pad);
extern int stfltnull(float value,char *pad,short null);
extern float ldfltnull(char *pad,short *null);
extern int stdblnull(double value,char *pad,short null);
extern double lddblnull(char *pad,short *null);
extern int isopen(char *name,int mode);
extern int isgetmode(int isfd,int *mode);
extern int issetmode(int isfd,int mode);
extern int isclose(int isfd);
extern int iscleanup(void );
extern int isstart(int isfd,struct keydesc *key,int len,char *data,int mode);
extern int isread(int isfd,char *data,int mode);
extern int isindex(int isfd,int idx,int locate);
extern int isgoto(int isfd,ISAMSIGNTYPE long recnum);
extern int ispush(int isfd,int *idx,ISAMSIGNTYPE long *rec);
extern int ispop(int isfd,int idx,ISAMSIGNTYPE long rec);
extern int isdata(int isfd,char *pad,ISAMSIGNTYPE long recnum);
extern ISAMSIGNTYPE long *is_recnum(int isfd);
extern int *is_reclen(int isfd);
extern int *is_errno(int isfd);
extern int *is_errio(int isfd);
extern int isfilter(int isfd,int (*filter)(int ,char *,int ));
static int rdfilter(struct IsamFile *isam,int isfd,char *data,int mode);
extern int isWrapFind(struct IsamFile *isam);
extern struct IsamFile *isWrapInit(int isfd);
extern int isWrapDone(struct IsamFile *isam,int ok);
extern int isWrapRet(int ok);
extern int iswrite(int isfd,char *data);
extern int iswrlock(int isfd,char *data);
extern int iswrcurr(int isfd,char *data);
extern int isrewrite(int isfd,char *data);
extern int isrewrec(int isfd,ISAMSIGNTYPE long recnum,char *data);
extern int isrewcurr(int isfd,char *data);
extern int isrewnxt(int isfd,char *data);
extern int isdelete(int isfd,char *data);
extern int isdelrec(int isfd,ISAMSIGNTYPE long recnum);
extern int isdelcurr(int isfd);
extern ISAMSIGNTYPE long isgetmask(int isfd);
extern int issetmask(int isfd,ISAMSIGNTYPE long mask);
