/*
-----------------------------------------------------------------------------
isremote.h - used by base/isclient.c and server/risamsrv.c     
-----------------------------------------------------------------------------

 +--------------------------------------------------------------------------+
 | Worldwide Copyright (c) 1987-2012 Byte Designs Ltd. All rights reserved. |
 |                                                                          |
 |                            20568 - 32 Avenue                             |
 |                               LANGLEY, BC                                |
 |                             V2Z 2C8 CANADA                               |
 |                                                                          |
 |                       Sales: sales@bytedesigns.com                       |
 |                     Support: support@bytedesigns.com                     |
 |              Phone: (604) 534 0722     Fax: (604) 534 2601               |
 +--------------------------------------------------------------------------+
                                Version 7.0

-----------------------------------------------------------------------------
*/
#include <isconfig.h>

#if defined _WIN32 && !defined _UWIN
#include <sys\types.h>
typedef struct flock
 {
 short l_type;
 short l_whence;
 off_t l_start;
 off_t l_len;
 short l_sysid;
 short l_pid;
 } flock;

/* unix fcntl fake for remote system calls */
/* cmd values */
#define F_GETFD  1
#define F_SETFD  2
#define F_GETFL  3
#define F_SETFL  4
#define F_GETLK  5
#define F_SETLK  6 
#define F_SETLKW 7

/* fcntl l_type values */
#define F_RDLCK  01
#define F_WRLCK  02
#define F_UNLCK  03

/* lockf - lock modes */
#define F_ULOCK  0
#define F_LOCK   1
#define F_TLOCK  2
#define F_TEST   3

typedef unsigned short mode_t; /* comment if system types.h defines mode_t */
#else
#include <fcntl.h>
#endif

/* for the recnum vecs */
#define MAXFDS 1024
#define MAXBUFSIZE 6144
#define USERINFOSIZE 10
#define CLIENT_LIMIT 10

/* clients must know this port number to connect
 */
#define PORTNUM 5002    /* can be overriden by env var RISAMPORT */

#ifndef NULL
#define NULL 0
#endif


#define ISBIG 'B'
#define ISLITTLE 'L'

/* a message must contain len and request, so has a minimum
 * length. (some requests have no input args required)
 *   NOTE: all messages now have isfd as common element ...
 *         set by the routines, -1 if n/a
 */
#define MIN_LENGTH 1
#define MIN_REPLY_LENGTH 1
#define MIN_REQUEST_LENGTH (4 * sizeof(int) )
#define ERRSONLY   (4 * sizeof(int) + sizeof(long))

/* requests
 */
#define DO_ISBUILD       1000
#define DO_ISVBUILD      1001
#define DO_ISADDINDEX    1002
#define DO_ISDELINDEX    1003
#define DO_ISCLUSTER     1004
#define DO_ISCLONE       1005
#define DO_ISCOPY        1006
#define DO_ISERASE       1007
#define DO_ISRENAME      1008
#define DO_ISFLUSH       1009
#define DO_ISSETUNIQUE   1010
#define DO_ISUNIQUEID    1011
#define DO_ISPRECIOUS    1012
#define DO_ISLOCKCHECK   1013
#define DO_ISSEEKEY      1014
#define DO_ISINDEXINFO   1015
#define DO_ISISAMINFO    1016
#define DO_ISUSERINFO    1017
#define DO_ISDI_NAME     1018
#define DO_ISDI_DATLEN   1019
#define DO_ISDI_CURIDX   1020
#define DO_ISDI_IDXFD    1021
#define DO_ISDI_DATFD    1022
#define DO_ISDI_KDSC     1023
#define DO_ISLOCK        1024
#define DO_ISUNLOCK      1025
#define DO_ISRELEASE     1026
#define DO_ISRELREC      1027
#define DO_ISRELCURR     1028
#define DO_ISOPEN        1029
#define DO_ISGETMODE     1030
#define DO_ISSETMODE     1031
#define DO_ISCLOSE       1032
#define DO_ISCLEANUP     1033
#define DO_ISSTART       1034
#define DO_ISREAD        1035
#define DO_ISINDEX       1036
#define DO_ISGOTO        1037
#define DO_ISPUSH        1038
#define DO_ISPOP         1039
#define DO_ISDATA        1040
#define DO_ISFILTER      1041
#define DO_IS_RECNUM     1042
#define DO_IS_RECLEN     1043
#define DO_IS_ERRNO      1044
#define DO_IS_ERRIO      1045
#define DO_ISLOGOPEN     1046
#define DO_ISLOGCLOSE    1047
#define DO_ISBEGIN       1048
#define DO_ISCOMMIT      1049
#define DO_ISROLLBACK    1050
#define DO_ISRECOVER     1051
#define DO_ISSUSPLOG     1052
#define DO_ISRESUMLOG    1053
#define DO_ISTXNID       1054
#define DO_ISAUDIT       1055
#define DO_ISWRITE       1056
#define DO_ISWRLOCK      1057
#define DO_ISWRCURR      1058
#define DO_ISDELETE      1059
#define DO_ISDELREC      1060
#define DO_ISDELCURR     1061
#define DO_ISREWRITE     1062
#define DO_ISREWREC      1063
#define DO_ISREWCURR     1064
#define DO_ISREWNXT      1065
#define DO_ISGETMASK     1066
#define DO_ISSETMASK     1067
#define DO_ISTHREADED    1068

#define DO_ISLASTREC     1069
#define DO_ISGETLASTREC  1070
#define DO_ISSETLASTREC  1071
#define DO_ISCHECKDATA	 1072
#define DO_ISCHECKINDEX  1073
#define DO_ISCHECKVARLEN 1074

#define DO_ISLDSCHEMA    1080
#define DO_ISDPSCHEMA    1081
#define DO_ISSTSCHEMA    1082
#define DO_ISRMSCHEMA    1083

#define DO_RLSEEK	 1200
#define DO_ROPEN	 1201
#define DO_RCLOSE	 1202
#define DO_RREAD	 1203
#define DO_RWRITE	 1204
#define DO_RFCNTL        1205
#define DO_RLOCKF	 1206
#define DO_RCREAT        1207
#define DO_RLSEEK64      1208
#define DO_ROPEN64       1209
#define DO_RLOCKF64      1210
#define DO_RCREAT64      1211
#define DO_RUNLINK       1212
#define DO_RLINK	 1213
#define DO_RSOPEN	 1214
#define DO_RFOPEN	 1215
#define DO_RFCLOSE	 1216
#define DO_RFREAD	 1217
#define DO_RFWRITE	 1218
#define DO_RFGETS	 1219
#define DO_RFPUTS	 1220
#define DO_RFPRINTF	 1221
#define DO_RFSEEK	 1222
#define DO_RFERROR	 1223
#define DO_RFEOF	 1224
#define DO_RREWIND	 1225
#define DO_RFTELL	 1226
#define DO_RFPUTC	 1227
#define DO_RFFLUSH	 1228
#define DO_RFGETC	 1229
#define DO_RFSTAT	 1230
#define DO_RPOPEN	 1231
#define DO_RPCLOSE	 1232
#define DO_RACCESS	 1233

#define DO_IS_RECNUM_SET 2042
#define DO_IS_RECLEN_SET 2043
#define DO_IS_ERRNO_SET  2044
#define DO_IS_ERRIO_SET  2045

/* used by odbc version of server */
#define DO_IS_GETINIINFO 8001
#define DO_IS_PUTINIINFO 8002
#define DO_IS_GETENDIAN  8003

/* exception codes */
#define CLIENT_DONE      9000
#define SHUT_DOWN_SERVER 9999
#define RET_CODE_INVALID -1000

#define ACK 0x5AA5

/* end header -------------------------------------------------------*/
typedef struct _replybuf
          {
          int	retcode;
          int	rperrno;
          int	rperrio;
          unsigned long	rprecnum;
          int	rpreclen;
          } STATBUF;

  /* reply variables. service routine prepares a reply and makes
   * reply point to it, with replylen set to length in bytes.
   * rbuf is used to send multiple packets if reply is long
   */
typedef  struct _reply
    {
    int replylen;		/* length of reply in bytes */
    int reply_allocated;
    char *reply;		/* functions point this to their reply */
    } REPLY;

/* message structure. len is the total length including args for
 * the specified request. ie, len of message transmitted.
 */
struct request_message
{
  char endian_type; /* lets server know if client is big or little */
  int len;
  int request;
  int isfd;
  union
  {
    /* args for requests. each function interprets based
     * on request type
     */
   char rqb[6000];   /* force it to be big enough */
   struct {int len; int max; int maxparts; int kdlen;
           int mode; struct keydesc kdsc;
		               char name[1]; }    isbuild_parms;
   struct {int len; int max; int maxparts; int kdlen;
           int mode; struct keydesc kdsc;
		               char name[1]; }    isvbuild_parms;
   struct { struct keydesc kdsc; }                isaddindex_parms;
   struct { struct keydesc kdsc; }                isdelindex_parms;
   struct { struct keydesc kdsc; }                iscluster_parms;
   struct { char name[1]; }                       isclone_parms;
   struct { int dfd; int sfd; struct keydesc kdsc; }        iscopy_parms;
   struct { char name[1]; }                                 iserase_parms;
   struct { char oname[500]; char nname[500]; }             isrename_parms;
   struct { unsigned long value; }                issetunique_parms;
   struct { long id; }                            isuniqueid_parms;
   struct { int flag; }                           isprecious_parms;
   struct { int flag; }                           islockcheck_parms;
   struct { int idx; }                            isindexinfo_parms;
   struct { struct dictinfo dest; }               isisaminfo_parms;
   struct { int mode; char pad[USERINFOSIZE]; }   isuserinfo_parms;
   struct { unsigned long last; }                 islastrec_parms;
   struct { unsigned long last; }                 isgetlastrec_parms;
   struct { unsigned long last; }                 issetlastrec_parms;
   struct { unsigned long recnum; }               isrelrec_parms;
   struct { int mode; int maxparts; int kdlen;
            char name[1]; }                       isopen_parms;
   struct { int mode; }                           isgetmode_parms;
   struct { int mode; }                           issetmode_parms;
   struct { int len; int mode; int keyparm;
            struct keydesc key; char data[1]; }   isstart_parms;
   struct { int mode; int reclen; unsigned long recnum;
            char data[1]; }                       isread_parms;
   struct { int idx; int locate; }                isindex_parms;
   struct { unsigned long recnum; }               isgoto_parms;
   struct { int idx; unsigned long rec; }         ispop_parms;
   struct { unsigned long recnum; char pad[1]; }  isdata_parms;
   struct { int ( *filter )(int,char*,int); }     isfilter_parms;
   struct { unsigned long recnum; }               is_recnum_set_parms;
   struct { int reclen; }                         is_reclen_set_parms;
   struct { int serrno; }                         is_errno_set_parms;
   struct { int serrio; }                         is_errio_set_parms;
   struct { char name[1]; }                       islogopen_parms;
   struct { int value; }                          istxnid_parms;
   struct { int mode ; char pad[1]; }             isaudit_parms;
   struct { int reclen; char data[1]; }           iswrite_parms;
   struct { int reclen; char data[1]; }           iswrlock_parms;
   struct { int reclen; char data[1]; }           iswrcurr_parms;
   struct { char data[1]; }                       isdelete_parms;
   struct { unsigned long recnum; }               isdelrec_parms;
   struct { int reclen; char data[1]; }           isrewrite_parms;
   struct { int reclen; unsigned long recnum; char data[1]; }
                                                  isrewrec_parms;
   struct { int reclen; char data[1]; }           isrewcurr_parms;
   struct { int reclen; char data[1]; }           isrewnxt_parms;
   struct { unsigned long mask; }                 issetmask_parms;
   struct { int idx; }                            ischeckindex_parms;
   struct { char ServerName[128]; char ServerDSN[256];} risgetiniinfo_parms;
   struct { char ServerName[128]; char ServerDSN[256];} risputiniinfo_parms;

   struct { char path[1]; }                       isldschema_parms;
   struct { char loadfile[1]; }                   isstschema_parms;

   struct { int file; off_t offset; int whence; } rlseek_parms;
   struct { int oflag; int mode; char name[1]; }  ropen_parms;
   struct { int oflag; int mode; int access;
            char name[1]; }                       rsopen_parms;
   struct { int file; }				  rclose_parms;
   struct { int file; int len; char data[1]; }    rread_parms;
   struct { int file; int len; char data[1]; }    rwrite_parms;
   struct { int file; int cmd; struct flock arg; }
                                                  rfcntl_parms;
   struct { int file; int function; long size; }  rlockf_parms;
   struct { int mode; char name[1]; }             rcreat_parms;
   struct { char name[1]; }                       runlink_parms;
   struct { char path[1]; char newpath[1]; }      rlink_parms;
   struct { int file; char data[1]; }		  rfstat_parms;
#if( ISHUGE == 1 )
   struct { int file; OFFT offset;       
            int whence; }                         rlseek64_parms;
   struct { int oflag; int mode; 
            char name[1]; }                       ropen64_parms;
   struct { int file; int function; 
            OFFT size; }                          rlockf64_parms;
   struct { int mode; char name[1]; }             rcreat64_parms;
#endif
   struct { int mode; char name[1]; }		  raccess_parms;
   struct { char name[255]; char mode[255]; }	  rpopen_parms;
   struct { int fid; }				  rpclose_parms;
   struct { char name[255]; char mode[255]; }	  rfopen_parms;
   struct { int fid; }				  rfclose_parms;
   struct { size_t size; size_t items;
            int fid; char data[1]; }		  rfwrite_parms;
   struct { size_t size; size_t items;
            int fid; char data[1]; }		  rfread_parms;
   struct { int len; int fid; char data[1]; }	  rfgets_parms;
   struct { int fid; char data[1]; }		  rfputs_parms;
   struct { int fid; OFFT offset; int mode; }	  rfseek_parms;
   struct { int c; int fid; }			  rfputc_parms;
   struct { int fid; }				  rfeof_parms;
   struct { int fid; }				  rferror_parms;
   struct { int fid; }				  rftell_parms;
   struct { int fid; }				  rrewind_parms;
   struct { int fid; }				  rfflush_parms;
   struct { int fid; }				  rfgetc_parms;
 } u;
};

struct reply_message
{
  int len;
  int totlen;
  int seq;
  char data[6000];
};


