/*
-----------------------------------------------------------------------------
standard interface - wrapper library header
-----------------------------------------------------------------------------

 +--------------------------------------------------------------------------+
 | Worldwide Copyright (c) 1987-2012 Byte Designs Ltd. All rights reserved. |
 |                                                                          |
 |                            20568 - 32 Avenue                             |
 |                               LANGLEY, BC                                |
 |                             V2Z 2C8 CANADA                               |
 |                                                                          |
 |                       Sales: sales@bytedesigns.com                       |
 |                     Support: support@bytedesigns.com                     |
 |              Phone: (604) 534 0722     Fax: (604) 534 2601               |
 +--------------------------------------------------------------------------+
                                Version 7.0

-----------------------------------------------------------------------------
*/

#include <isbase.h>

#define ISINTERNAL 1

#include <iswrap.h>

#include <string.h>
#include <sys/types.h>


/* useful definitions -------------------------------------------- */

#define SUCCESS      0
#define DISAM_ERROR -1
#define ISLOCAL	     0
#define ISREMOTE     1

/* the global variables ------------------------------------------ */

#ifdef STDGLOBALS

 ISD1 unsigned long ISD2 isrecnum = 0;
 ISD1 int ISD2 isreclen = 0;
 ISD1 int ISD2 iserrno = 0;
 ISD1 int ISD2 iserrio = 0;
 ISD1 char *ISD2 ismirror=NULL;
 ISD1 pid_t ISD2 ispid = 0;
 
#else

 extern unsigned long isrecnum;
 extern int isreclen;
 extern int iserrno; 
 extern int iserrio;
 extern char *ISD2 ismirror;
 extern pid_t ispid;
#endif 


/* wrapper handling prototypes ----------------------------------- */

#ifdef __cplusplus
extern "C" {
#endif

#if( ISDECLARE )
# define ISD3(s) s
#else
# define ISD3(s) ()
#endif

#if( ISDATAVOID )
# define ISDT void
#else
# define ISDT char
#endif

int isWrapFind ISD3((IsFile *isam));
IsFile *isWrapInit ISD3((int isfd));
int isWrapDone ISD3((IsFile *isam, int ok));
int isWrapRet ISD3((int ok));
int isWrapTxn ISD3((int ok));
int isWrapFile ISD3((char *name));

#undef ISD3

#ifdef __cplusplus
};
#endif
